using System;

namespace TomerGabel.Examples
{

	class Container
	{
		public delegate void SomeEventHandler( string message );
		
		public event SomeEventHandler SomeEvent;
	}
	
	class Test
	{
		public static void Main()
		{
			new Test().Run();
		}

		public void Run()
		{
			Container cont = new Container();
			cont.SomeEvent += new Container.SomeEventHandler( cont_SomeEvent );
			
			AsyncHelper.Fire( cont, "SomeEvent", new EventHandler( helper_Done ), "test" );
			
			Console.ReadLine();
		}
		
		private void helper_Done( object sender, EventArgs e )
		{
			System.Diagnostics.Debug.WriteLine( "Event fired successfully" );
		}

		private void cont_SomeEvent( string message )
		{
			System.Diagnostics.Debug.WriteLine( message );
		}
	}
}
